diffeculty = 5


math.randomseed(os.time())
local size = 400/diffeculty--logic

local BOXES = {}

local DIDHESOLVEIT = false

function make_board()
	size = 400/diffeculty--logic
	BOXES = {}
	for x = 1,diffeculty do
		for y = 1,diffeculty do
			BOX = {O = math.random(0,1), X = x, Y = y, C = 0}
			table.insert(BOXES,BOX)
		end		
	end
	for i,v in pairs(BOXES) do
		if v.X == 1 then
			v.O = 1
		end
	end
end
make_board()

function findnumberx(x)
	local n = {}
	local c = 0
	for i,v in pairs(BOXES) do
		if v.X == x then
			if v.O == 1 then
				c = c+1
			else
           			if c > 0 then 
              				 table.insert(n, tostring(c))
            			end
            			c = 0
         		end
     		 end
   	end
	if c > 0 then
		table.insert(n, tostring(c))
	end
	return table.concat(n, ",")
end
function findnumbery(y)
	local n = {}
	local c = 0
	for i,v in pairs(BOXES) do
		if v.Y == y then
			if v.O == 1 then
				c = c+1
			else
           			if c > 0 then 
              				 table.insert(n, tostring(c))
            			end
            			c = 0
         		end
     		 end
   	end
	if c > 0 then
		table.insert(n, tostring(c))
	end
	return table.concat(n, ",")
end

function love.load()
	button_off = love.graphics.newImage("BUTTONOFF.png")
	button_on = love.graphics.newImage("BUTTONON.png")
	button_not = love.graphics.newImage("BUTTONNOT.png")
end

function love.draw()
	for i,v in pairs(BOXES) do
		if v.C == 0 then 
			love.graphics.draw(button_off,v.X*size,v.Y*size,0,size/30,size/30,0,0)
		elseif v.C == 1 then
			love.graphics.draw(button_on,v.X*size,v.Y*size,0,size/30,size/30,0,0)
		elseif v.C == 2 then
			love.graphics.draw(button_not,v.X*size,v.Y*size,0,size/30,size/30,0,0)
		end

	end
	for x = 1,diffeculty do
		love.graphics.print(findnumberx(x), x*size, size-40)
	end
	for y = 1,diffeculty do
		love.graphics.print(findnumbery(y), size-40, y*size)
	end
	
	if DIDHESOLVEIT then
		love.graphics.print("WOOOOOHOOOOO",10,10)
	end
end

function love.mousepressed(mx,my,mouse)
	for i,v in pairs(BOXES) do
		local inbox = mx > v.X*size and my > v.Y*size and mx < v.X*size+size and my < v.Y*size+size
		if inbox then
			if mouse == "l" then
				if v.C == 0 or v.C == 2 then
					v.C = 1
				else
					v.C = 0
				end
			elseif mouse == "r" then
				if v.C == 0 or v.C == 1 then
					v.C = 2
				else
					v.C = 0
				end
			end
		end
	end	
	DIDHESOLVEIT = true
	for i,v in pairs(BOXES) do
		F = v.C
		if F == 2 then F = 0 end
		if v.O == F then else
			DIDHESOLVEIT = false
		end
	end
end

function love.keypressed(key)
	if key == "up" or key == "w" then
		if diffeculty < 9 then
			diffeculty = diffeculty+1
			make_board()
		end
	elseif key == "down" or key == "s" then
		if diffeculty > 2 then
			diffeculty = diffeculty-1	
			make_board()
		end
	end
end
